<link rel="import" href="../polymer/polymer-element.html">

<dom-module id="dispath-event-element">
  <template>
    <style>
      :host {
        display: block;
      }
    </style>
    <h2>Dispatch Event Example</h2>
    <button on-click="handleClick">Lanzar evento</button>
  </template>

  <script>
    /**
     * `dispath-event-element`
     * 
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class DispathEventElement extends Polymer.Element {
      static get is() { return 'dispath-event-element'; }
      static get properties() {
        return {
          prop1: {
            type: String,
            value: 'dispath-event-element'
          }
        };
      }
      constructor() {
        super();
        this.addEventListener('myEvent', function(e) {
          console.log(e.detail.data, Date.now(), "self");
        })
      }
      handleClick(e){
        this.dispatchEvent(new CustomEvent('myEvent', {detail: {data: true}}));
      }
    }

    window.customElements.define(DispathEventElement.is, DispathEventElement);
  </script>
</dom-module>
